#!/usr/bin/perl -w

# Written by Simon Huggins
# (C) Project Purple 1999
# 24/7/1999 - started
 
use strict;
use English;
use Carp;

print "Filtermail v0.0.1 (C) Project Purple 1999 released under the GPL\n";
print "Decide action to take on cached message headers\n\n";

# One action per regexp (when regexp matches return action)
my (@actions, @regexps, $num_actions, $idline, $finished, $newmsg);

$num_actions=0;

# Action	Meaning
# 
# N/A (0 for filtermail.pl)	Leave on server, add to cache, get users idea.
# 1				Get.
# 2				Delete.
# 3				Leave, but already in cache.

### Create the instructions for Message IDs
$idline="";
open(CACHE, "<cache") or croak "Couldn't open message header cache!";
$newmsg=1;
while (<CACHE>) {
	if ($newmsg) {
		print "Message\n=======\n";
		$newmsg=0;
	}
	if (/^Message-ID:/i) { chomp($idline = $_); }
	if (/^---SIZE=(.*)$/) {
		my $response;
		print "Size = $1\n";
		do {
			$finished=1;
			print "G)et, D)elete, L)eave this message?";
			$response = <STDIN>;
			if ($response =~ /^[gG]$/) {
				if ($idline eq "") { croak "Erk! No Message-ID:"; } # FIXME
				push @actions, 1;
				push @regexps, '^' . quotemeta($idline) . '$';
				$num_actions++;
			} elsif ($response =~ /^[dD]$/) {
				if ($idline eq "") { croak "Erk! No Message-ID:"; } # FIXME
				push @actions, 2;
				push @regexps, '^' . quotemeta($idline) . '$';
				$num_actions++;
			} elsif ($response =~ /^[lL]$/) {
				if ($idline eq "") { croak "Erk! No Message-ID:"; } # FIXME
				push @actions, 3;
				push @regexps, '^' . quotemeta($idline) . '$';
				$num_actions++;
			} else {
				$finished=0;
			}
		} while (not $finished);
		$newmsg=1;
		$idline="";
	} else {
		print; # print all headers but the ---SIZE one
	}
}
close CACHE;

unlink('cache');

open(INST, ">>instructions");
for (my $i=0; $i<$num_actions; $i++) {
	print INST $actions[$i] . " " . $regexps[$i] . "\n";
}
close(INST);
